unit frmMain;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls;

type
  TForm1 = class(TForm)
    btnNormalCall: TButton;
    Memo1: TMemo;
    btnRttiCallSimple: TButton;
    btnRttiCallParams: TButton;
    edZipCode: TEdit;
    procedure btnNormalCallClick(Sender: TObject);
    procedure btnRttiCallSimpleClick(Sender: TObject);
    procedure btnRttiCallParamsClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses Weather, System.Rtti, TypInfo;

procedure TForm1.btnNormalCallClick(Sender: TObject);
var
  soap: WeatherSoap;
  res:  ArrayOfWeatherDescription2;
  I:  Integer;
begin
  soap := GetWeatherSoap(False,'',nil);
  res := soap.GetWeatherInformation;
  for I := 0 to Length(res) - 1 do
    Memo1.Lines.Add(Format('%d %s %s', [res[I].WeatherID, res[I].Description, res[I].PictureURL]));
end;

procedure TForm1.btnRttiCallSimpleClick(Sender: TObject);
var
  soap: WeatherSoap;
  res:  ArrayOfWeatherDescription2;
  req:  string;
  I:  Integer;
  C: TRttiContext;
  T: TRttiType;
  M: TRttiMethod;
  Param: TArray<TValue>;
  TVres: TValue;
begin
  req := 'GetWeatherInformation';
  C := TRttiContext.Create;
  T := C.FindType('Weather.WeatherSoap');
  M := T.GetMethod(req);
  soap := GetWeatherSoap(False,'',nil);
  SetLength(Param,0);
  TVres := M.Invoke(TValue.From<IInterface>(soap), Param);
  res := TVres.AsType<ArrayOfWeatherDescription2>;
  for I := 0 to Length(res) - 1 do
    Memo1.Lines.Add(Format('%d %s %s', [res[I].WeatherID, res[I].Description, res[I].PictureURL]));
end;

procedure TForm1.btnRttiCallParamsClick(Sender: TObject);
var
  soap: WeatherSoap;
  res:  ForecastReturn2;
  req:  string;
  I:  Integer;
  C: TRttiContext;
  T: TRttiType;
  M: TRttiMethod;
  Param: TArray<TValue>;
  TVres: TValue;
begin
  req := 'GetCityForecastByZIP';

  C := TRttiContext.Create;
  T := C.FindType('Weather.WeatherSoap');
  M := T.GetMethod(req);
  soap := GetWeatherSoap(False,'',nil);
  SetLength(Param,1);
  Param[0] := TValue.From<string>(edZipCode.Text);
  TVres := M.Invoke(TValue.From<IInterface>(soap), Param);
  res := TVres.AsType<ForecastReturn2>;
  Memo1.Lines.Add(Format('%s %s %s', [res.State, res.City, res.WeatherStationCity]));
end;

end.
